import java.util.ArrayList;
import java.util.Random;

public class Provider {
	private static final int INITIAL_RNDNO_SIZE = 16;
	private static final int RANDOM_UPPER_BOUND = 100;
	private int[] rndNo;
	private int rndNoCnt;
	private Random rnd;

	public Provider() {
		rndNoCnt = 0;
		rndNo = new int[INITIAL_RNDNO_SIZE];
		rnd = new Random();
	}


	private void generateRandomNumbers(int length) {
		int[] newRndNo;

		while (rndNoCnt < length) {
			if (rndNoCnt >= rndNo.length) {
				newRndNo = new int[rndNoCnt*2];
				System.arraycopy(rndNo, 0, newRndNo, 0, rndNoCnt);
				rndNo = newRndNo;
			}
			rndNo[rndNoCnt] = rnd.nextInt(RANDOM_UPPER_BOUND);
			++rndNoCnt;
		}
	}

	public ListNode getList(int length) {
		ComparableListNode root=null, cur;

		generateRandomNumbers(length);
		if (length >= 1) {
			root = new ListNode(rndNo[0]);
			cur = root;
			for (int i = 1; i < length; ++i) {
				cur.setNext(new ListNode(rndNo[i]));
				cur = cur.getNext();
			}
		}

		return (ListNode) root;
	}

	public Node[] getArray(int length) {
		Node[] result;

		generateRandomNumbers(length);
		result = new Node[length];
		for (int i = 0; i < length; ++i) {
			result[i] = new Node(rndNo[i]);
		}

		return result;
	}

}
